/*
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

use crate::report::glean::schema::Glean;
use crate::state::handle::Handle;
use crate::state::state::Transaction;

pub mod convert;
pub mod schema;

pub fn glean(transaction: &Transaction, handle: &Handle) -> String {
    fn f(transaction: &Transaction, handle: &Handle) -> Option<Glean> {
        Some(Glean::new(
            &transaction.get_module_info(handle)?,
            &*transaction.get_ast(handle)?,
            &transaction.get_bindings(handle)?,
            &*transaction.get_answers(handle)?,
        ))
    }

    let data = f(transaction, handle).expect("Glean data be ready");
    serde_json::to_string_pretty(&data).unwrap()
}
